#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <stdio.h>
#include <usb.h>
#include <sys/ioctl.h>
#include <dev/usb/usb.h>

#define USB_ERROR -1

static char init1[]={ 0x80, 0x01, 0x00, 0x20, 0x14 };
static char init2[]={ 0x80, 0x01, 0x00, 0x20, 0x14, 0x20, 0x20, 0x20 };

main (int argc, char **argv)
{
	int fd;
	int rfd, wfd;
	int err;
	int iov;
	int n;
	char c[255];
	usb_device_descriptor_t usbdd;

	fd = open ("/dev/ugen0", O_RDWR);
	if (fd  == -1)
		{ perror ("Open ugen0"); exit(1); }

	err = ioctl(fd, USB_GET_DEVICE_DESC, &usbdd);
	if (err == -1)
		{ perror ("Get device descriptor"); exit(1); }

	rfd = open ("/dev/ugen0.1", O_RDONLY|O_NONBLOCK);
	if (rfd == -1)
		{ perror ("Open ugen0.1"); exit(1); }
	iov = 1;
	err = ioctl (rfd, USB_SET_SHORT_XFER, &iov);
	if (err == -1)
		{ perror ("Set short XFER"); exit(1); }

	iov = 5000;
	err = ioctl (rfd,  USB_SET_TIMEOUT, &iov);
	if (err == -1)
		{ perror ("Set Timeout"); exit(1); }

	wfd = open ("/dev/ugen0.2", O_WRONLY);
	if (wfd == -1)
		{ perror ("Open ugen0.2"); exit(1); }

	err = write (wfd, init1, sizeof(init1));
	if (err != sizeof(init1))
		{ perror ("Write init1"); exit(1); }
	err = write (wfd, init2, sizeof(init2));
	if (err != sizeof(init2))
		{ perror ("Write init2"); exit(1); }

	while (n = read (rfd, c, 255)) write (1, c, n);
}
